'use strict';
var lwip;
var path = require('path');
try {lwip = require('lwip');}
catch(e) {
  lwip = null
  console.log('WARNING! LWIP is not installed - image minification won\'t work.');
  console.log('You can try to run npm install.');
  console.log('If it does not help try to make npm install lwip work.');
}
var mkdirp = require('mkdirp');
var path = require('path');

module.exports = function(file, targetDir, width, height) {
  if(lwip && (width || height)) {
    let tmp = path.basename(file).split('.');
    tmp.splice(-1,1);
    let base = tmp.join('.');
    let targetFile = base+'_thumb_';
    if(width) targetFile += width;
    targetFile += 'x';
    if(height) targetFile += height;
    targetFile += '.png';
    let ret = targetFile;
    targetFile = path.resolve(targetDir,targetFile);
    lwip.open(file, function(err, image) {
      function doResize() {
        mkdirp(path.dirname(targetFile), function() {
          image.batch()
          .resize(width, height)
          .writeFile(targetFile, function(err) {
            if(err) console.log(err);
          });
        }
      }

      if(err) return console.log(err);
      var w = image.width(), h = image.height();
      if(width && height) {
        doResize();
      } else if(height) {
        if(h > height) {
          width = Math.round(height*w/h);
          doResize();
        }
      } else if(width) {
        if(w > width) {
          height = Math.round(width*h/w);
          doResize();
        }
      } else {
        console.log(new Error('Panic! Code should never get here!'));
      }
    })
    return ret;
  } else {
    return path.basename(file);
  }
}
